cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
/***********************************************************************

		pscrip: reads Unix standard plot file from
		standard input, makes new one in postscript
                format
                output is in real inches, to convert to VAX
                laser printer scale use sed to convert scale
                command in output file from "0.072 0.072 scale" to
                "0.054 0.054 scale"
		To compile execute:  cc pscrip.c

	Jan 6 1988, Cathy Constable
	modified Oct 27 1988
	modified Jul 27 1989 R. L. Parker

  rev. history: Butchered from turn.c which was butchered from zeta.c
	see u1/local/src/plotxy/turn.c
	see /usr/local/src/zeta/zeta.c.
        This is the source for the zeta filter. 

***********************************************************************/


#include <stdio.h>
#include <math.h>

#define TRUE		1
#define FALSE		0



/**** assorted globals ****/
unsigned short xx,yy;

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

main()
{


/*** read data from standard input and output to stdout ***/

psc();

exit(0);

} /* end of main program */

/***********************************************************************

	psc(): reads plot commands from stdin
	and takes appropriate action for 'm','n' ONLY
	Other commands are ignored except 'h' which 
        generates linewidth commands instead of color,
        line width increments are 1/1000", smallest 
        width is 5/1000"
	no return value

***********************************************************************/

#define MAXBUFF		256

psc()
{
unsigned char inbuff[MAXBUFF];
int bytesread,i;
/*Color table giving: 0 black, 1 black, 2 red, 3 blue, 4 green, 
                      5 brown, 6 orange, 7 purple                 */
static float hsb1[8]={0.,0.,0.,.67,.33,.10,.10,.83};
static float hsb2[8]={0.,0.,1.,1., 1., 1., 1., 1.};
static float hsb3[8]={0.,0.,1.,1., 1.,.7,  1., 1.};

/**write header for postscript file**/

printf ("%%!\n");
printf ("initmatrix \n");
printf ("/m\n");
printf ("{newpath moveto}def\n");
printf ("/n\n");
printf ("{lineto currentpoint stroke moveto}def\n");
printf ("0.072 0.072 scale %%Coords are in 1/1000th inches\n");
printf ("2 setlinejoin\n");
printf ("4 setlinewidth\n");
printf ("1 setlinecap\n");
printf ("newpath\n");

/** Read info from plotfile and convert to Postscript commands**/
do {

	bytesread = fread(inbuff,1,1,stdin);
	if (!bytesread) break;			/* quit do loop */

	switch (inbuff[0]) {	/* determine plot command */

	/*** move: 4 more bytes ***/
	case 'm': bytesread = fread(inbuff,1,4,stdin);
		/*** translate to integers ***/
		  xx = inbuff[0] + 0x100 * inbuff[1];
		  yy = inbuff[2] + 0x100 * inbuff[3];
                  printf("%d %d m\n",xx,yy);
                    /*** output new coords ***/
		  break;

	/*** cont: 4 more bytes ***/
	case 'n': bytesread = fread(inbuff,1,4,stdin);
		/*** translate to integers ***/
		  xx = inbuff[0] + 0x100 * inbuff[1];
		  yy = inbuff[2] + 0x100 * inbuff[3];
                  printf("%d %d n\n",xx,yy);
                       /*** output new coords ***/
		  break;

	/*** new pen: 1 more byte (Extension to standard***/
	case 'h': bytesread = fread(inbuff,1,1,stdin);
	  	i = (int)inbuff[0]; 
                if (i >=0 && i < 8) 
                printf("%6.2f %6.2f %6.2f  sethsbcolor \n",
                       hsb1[i],hsb2[i],hsb3[i]);
		break;


	/*** point: 4 more bytes ***/
	case 'p': bytesread = fread(inbuff,1,4,stdin);
		  break;

	/*** line: 8 more bytes ***/
	case 'l': bytesread = fread(inbuff,1,8,stdin);
		  break;

	/*** label: may have up to MAXBUFF bytes ***/
	case 't': for (i=0; i < MAXBUFF; i++) {
		     bytesread = fread(&inbuff[i],1,1,stdin);
		     if (inbuff[i] == '\n') break;
		     };
		  break;

	/*** arc: 12 bytes ***/
	case 'a': bytesread = fread(inbuff,1,12,stdin);
		  break;

	/*** circle: 6 bytes ***/
	case 'c': bytesread = fread(inbuff,1,6,stdin);
		  break;

	/*** erase: no additional bytes ***/
	case 'e': exit(0);			/* terminate this plot */
		  break;

	/*** linemod: from 5 to 12 more bytes ***/
	case 'f': for (i=0; i< 12; i++) {
		     bytesread = fread(&inbuff[i],1,1,stdin);
		     if (inbuff[i] == '\n') break;
		     };
		  break;

	case 's': bytesread = fread(inbuff,1,8,stdin);
		  break;

	/********************************************************
	*** the following are command extensions to standard  ***
	/*** pen speed: one more byte ***/
	/*** pen speed is altered for all following plots ***
	 *** (until next pen speed instruction).          ***/
	case 'o': bytesread = fread(inbuff,1,1,stdin);
		  i = (int)inbuff[0];
		  break;

	/*** default: ignore and continue with fingers crossed ***/
	default:  fprintf(stderr,
			  "pscrip: unknown instruction - warning\n");
		  break;

	}; /* switch */

} while (bytesread);

/* Write tail of Postscript file*/

printf ("stroke\nshowpage\nquit\n");

} /* end of psc() */

/*** END OF FILE PSCRIP.C ***/

